import { basename, isAbsolute, join } from 'path';
import { existsSync, lstatSync, unlinkSync } from 'fs';
import { NodeHelpers } from '@muffin-dev/js-helpers';

/**
 * @interface ICleaneablePath Represents a file, a file extension or a directory that can be cleaned.
 */
interface ICleaneablePath {
  /**
   * @property Defines the maximum version of Unity that the given path should be cleaned. If the given path must be cleaned whatever the
   * version of Unity, use "*".
   * This feature is not supported yet.
   */
  // version: string;

  /**
   * @property Defines the path to the file or the directory that can be cleaned. You can also specify a file extension, by giving a string
   * that starts with "." or "*.".
   */
  path: string;
}

/**
 * @constant UNITY_MIN_DIRECTORY Defines what are the directories that the utility must find to verify the given input path as a Unity
 * project directory.
 */
const UNITY_MIN_DIRECTORY = [
  'Assets',
  'ProjectSettings'
];

const CLEANEABLE_FILES: ICleaneablePath[] = [
  // Generated by Unity
  { path: '/Library' },
  { path: '/Logs' },
  { path: '/obj' },
  { path: '/Temp' },
  // VS Code cache
  { path: '/.vs' },
  { path: '/.vscode' },
  // Visual Studio solution files
  { path: '*.csproj' },
  { path: '*.sln' },
  { path: '*.suo' },
];

/**
 * Cleans a Unity project directory, by removing all the automatically-generated files (such as Visual Studio solutions, Unity cache, logs,
 * ...). Note that it won't work if the given path is not a valid Unity project directory.
 * @async
 * @param path The path to the Unity project directory to clean. If null given, uses "./". If undefined given, log an error.
 * @param recursive If true, search for all Unity projects in all sub-folder from the given path, and clean them all.
 * @returns Returns true if the operation is successful, otehrwise false.
 */
export async function clean(path: string, recursive = false) {
  // Fix path
  if(path === undefined) {
    console.warn('Error: No path have been passed to the CLI. Usage: unity-directory-cleaner /path/to/your/unity/project');
    return false;
  }

  if(path === null) {
    path = './';
  }

  if(!isAbsolute(path)) {
    path = join(process.cwd(), path);
  }

  // If the recursive option is enabled
  if(recursive) {
    // Get all sub-directories at the given path
    console.log('Searching for Unity project directories...');
    const dirs = await NodeHelpers.readdirAsync(path, true, false, null, true, true);
    console.log('');
    let unityDirFound = false;

    // For each directory
    for(const dir of dirs) {
      const isUnityDir = await isUnityProjectDirectory(dir.path);
      // if the current directory contains a Unity project, clean it
      if(isUnityDir) {
        unityDirFound = true;
        await cleanDirectory(dir.path, true);
      }
    }

    if(unityDirFound) {
      console.log('');
      console.log('The directories have been cleaned!');
      return true;
    }
    else {
      console.log('Error: No Unity project directory have been found at the given path.');
      return false;
    }
  }

  // If the recursive option is disabled, try to clean the directory at the given path
  else {
    const success = await cleanDirectory(path);
    if(success) {
      console.log('');
      console.log('This directory have been cleaned');
    }
    return success;
  }
}

/**
 * Checks if the given path leads to a Unity project directory.
 * To be considered as a Unity project, the directory must contains sub-directories /Assets and /ProjectSettings.
 * @param path The path to the directory to check.
 */
async function isUnityProjectDirectory(path: string) {
  for(const dir of UNITY_MIN_DIRECTORY) {
    if(!existsSync(join(path, dir))) {
      return false;
    }
  }
  return true;
}

/**
 * Cleans a Unity project directory, by removing all the automatically-generated files (such as Visual Studio solutions, Unity cache, logs,
 * ...). Note that it won't work if the given path is not a valid Unity project directory.
 * @async
 * @param path The path to the Unity project directory to clean. If null given, uses "./". If undefined given, log an error.
 * @param trusted If true, don't check if the given path is a Unity project directory. Used by clean() method, to avoid checking for the
 * same thing twice.
 * @returns Returns true if the operation is successful, otehrwise false.
 */
async function cleanDirectory(path: string, trusted = false) {
  const isUnityDir = trusted ? true : await isUnityProjectDirectory(path);
  if(!isUnityDir) {
    // tslint:disable-next-line:max-line-length
    console.warn('Error: The given directory is not a Unity project. It must contains at least an /Assets and a /ProjectSettings directory.');
    return false;
  }

  const removalProcesses = new Array<Promise<any>>();

  // For each path to file or directory to clean
  for(const data of CLEANEABLE_FILES) {
    // Remove files that have the current extension
    if(data.path.startsWith('.') || data.path.startsWith('*.')) {
      const split = data.path.split('.');
      const ext = split[split.length - 1];
      const files = await NodeHelpers.readdirAsync(path, false, true, ext, true, true);
      for(const file of files) {
        console.log('Removing ' + file.path);
        removalProcesses.push(NodeHelpers.removeFile(file.path, true));
      }
    }
    // Remove file or directory at the current path
    else {
      const itemPath = join(path, data.path);
      if(existsSync(itemPath)) {
        if(lstatSync(itemPath).isFile()) {
          console.log('Removing ' + itemPath);
          removalProcesses.push(NodeHelpers.removeFile(itemPath, true));
        }
        else {
          console.log('Removing ' + itemPath);
          removalProcesses.push(NodeHelpers.removeDirectory(itemPath, true));
        }
      }
    }
  }

  await Promise.all(removalProcesses);
  return true;
}

export default clean;